#!/usr/bin/env python
"""
    gladex - Generate source code from Glade XML files.

    Copyright (C) 2007 See AUTHORS list for copyright holders

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
import sys
try:
     import pygtk
     pygtk.require("2.0")
except:
     pass
try:
     import gtk
     import gtk.glade
     import calculator_callbacks as callbacks
except:
     sys.exit(1)

class CalculatorClass:
     def __init__(self):
          # Set the Glade file
          self.gladefile = 'calculator.glade'
          self.wTree = gtk.glade.XML(self.gladefile)
          # Dictionary autogenerated by gladex.
                    # Dictionary autogenerated by gladex.
          dic = { "on_aboutdialog1_response" : lambda w, d="": self.calls("on_aboutdialog1_response",w,d),
	           "on_window1_expose_event" : lambda w, d="": self.calls("on_window1_expose_event",w,d),
	           "on_quit_activate" : lambda w, d="": self.calls("on_quit_activate",w,d),
	           "on_about_dialog_activate" : lambda w, d="": self.calls("on_about_dialog_activate",w,d),
	           "on_fowardinhistory_activate" : lambda w, d="": self.calls("on_fowardinhistory_activate",w,d),
	           "on_button_press" : lambda w, d="": self.calls("on_button_press",w,d),
	           "on_backinhistory_activate" : lambda w, d="": self.calls("on_backinhistory_activate",w,d) }
          self.wTree.signal_autoconnect(dic)
     ## Do not edit calls function
     def calls(self, callname, callwidget, calldata=''):
          try:
               func = dir(callbacks)
               i=func.index(callname)
               obj = getattr(callbacks, func[i])
               obj(callwidget, calldata, self.wTree)
          except:
               print 'function does not exsist'

if __name__ == '__main__':
     someclass = CalculatorClass()
     try:
          gtk.main()
     except KeyboardInterrupt:
          print "clean exit"
          gtk.main_quit()
