#!/usr/bin/env python
"""
    gladex - Generate source code from Glade XML files.

    Copyright (C) 2007 See AUTHORS list for copyright holders

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
import commands
import time
import sys
import os
import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade

		
def on_MainWindow_destroy(widget, data, wtree):
	gtk.main_quit()
	pass

def on_btnOpenGladeFile_clicked(widget, data, wtree):
	fw=wtree.get_widget("FileSelectionWindow")
	glade_file_filter = gtk.FileFilter()
	glade_file_filter.add_mime_type("glade")
	glade_file_filter.add_pattern("*.glade")
	fw.set_filter(glade_file_filter)
	fw.run()
	pass

def on_btnHelp_clicked(widget, data, wtree):
	d=gtk.MessageDialog()
	d.set_markup("Help function not implemented.")
	d.run()
	pass
def set_status(msg, wtree):
	statusbar = wtree.get_widget("statusbar1")
	statusbar.pop(1)
	statusbar.push(1, msg)

def on_btnConvert_clicked(widget, data, wtree):
	gladefile = wtree.get_widget("entry1").get_text()
	pythonfile = wtree.get_widget("entry2").get_text()
	classname = wtree.get_widget("entry3").get_text()
	callbacksfile = wtree.get_widget("entry4").get_text()
	
	## validate files ##
	# first, do all the feilds have a value
	if gladefile=="" or pythonfile=="" or classname=="" or callbacksfile=="":
		set_status("ERROR: one of the feilds are incomplete",wtree)
		return
	
	# does the glade file exsist
	try:
		g=open(gladefile)
	except:
		set_status("ERROR: glade file does not exsist",wtree)
		return
	
	#does python file ends in py?
	if pythonfile[-3:]!=".py":
		set_status("ERROR: python file must end in .py",wtree)
		return
	
	#does callbacks file ends in py?
	if callbacksfile[-3:]!=".py":
		set_status("ERROR: callbacksfile file must end in .py",wtree)
		return
	
	#everything checks out, run gladex
	out = commands.getoutput(os.path.split(__file__)[0]+"/gladex "+gladefile+" "+classname+" "+pythonfile+" "+callbacksfile)
	d=gtk.MessageDialog()
	d.set_markup(out)
	d.run()
	set_status("DONE: glade file converted",wtree)		

def on_btnCancel_clicked(widget, data, wtree):
	gtk.main_quit()
	pass

def on_FileSelectionWindow_destroy(widget, data, wtree):
	wtree.get_widget("FileSelectionWindow").hide()
	pass

def on_btnFileSelectorCancel_clicked(widget, data, wtree):
	wtree.get_widget("FileSelectionWindow").hide()
	pass

def on_btnFileSelectorOpen_clicked(widget, data, wtree):
	#print 'openfile: ', widget
	fw=wtree.get_widget("FileSelectionWindow")
	fw=fw.get_filename()
	ent = wtree.get_widget("entry1")
	name = fw[fw.rfind("/")+1:-6]
	ent2 = wtree.get_widget("entry2").set_text(name+".py")
	ent3 = wtree.get_widget("entry3").set_text(name[0].upper()+name[1:]+"Class")
	wtree.get_widget("entry4").set_text(name+"_callbacks.py")
	ent.set_text(fw)
	wtree.get_widget("FileSelectionWindow").hide()
	pass




